// Copyright (C) 2002-2007 Nikolaus Gebhardt
// This file is part of the "Irrlicht Engine".
// For conditions of distribution and use, see copyright notice in irrlicht.h

#ifndef __I_PARTICLE_MATERIAL_GLITTER_AFFECTOR_H_INCLUDED__
#define __I_PARTICLE_MATERIAL_GLITTER_AFFECTOR_H_INCLUDED__

#include "IParticleAffector.h"
#include "SColor.h"

namespace irr
{
namespace scene
{

//! A particle affector modifies particles.
class IParticleMaterialGlitterAffector : public IParticleAffector
{
public:

	//! Affects an array of particles.
	//! \param now: Current time. (Same as ITimer::getTime() would return)
	//! \param particlearray: Array of particles.
	//! \param count: Amount of particles in array.
	virtual void affect(u32 now, SParticle* particlearray, u32 count) = 0;

	//! Set the minimum specular color
	virtual void setMinSpecularColor( video::SColor minSpecularColor ) = 0;
	//! Set the maximum specular color
	virtual void setMaxSpecularColor( video::SColor maxSpecularColor ) = 0;
	//! Set the minimum ambient color
	virtual void setMinAmbientColor( video::SColor minAmbientColor ) = 0;
	//! Set the maximum ambient color
	virtual void setMaxAmbientColor( video::SColor maxAmbientColor ) = 0;
	//! Set the minimum diffuse color
	virtual void setMinDiffuseColor( video::SColor minDiffuseColor ) = 0;
	//! Set the maximum diffuse color
	virtual void setMaxDiffuseColor( video::SColor maxDiffuseColor ) = 0;

	//! Get the minimum specular color
	virtual const video::SColor& getMinSpecularColor() = 0;
	//! Get the maximum specular color
	virtual const video::SColor& getMaxSpecularColor() = 0;
	//! Get the minimum ambient color
	virtual const video::SColor& getMinAmbientColor() = 0;
	//! Get the maximum ambient color
	virtual const video::SColor& getMaxAmbientColor() = 0;
	//! Get the minimum diffuse color
	virtual const video::SColor& getMinDiffuseColor() = 0;
	//! Get the maximum diffuse color
	virtual const video::SColor& getMaxDiffuseColor() = 0;
};

} // end namespace scene
} // end namespace irr


#endif // __I_PARTICLE_MATERIAL_GLITTER_AFFECTOR_H_INCLUDED__

